import { getToolDetailById, listFileByBasisId, toolDelete } from "@/api/bussiness";
import { groupByKey } from "@/utils"
// 数据表格的 hooks
const useTable = (getList, updateTypeOneDict, reset, open, title,form,formLoading) => {
  const { proxy } = getCurrentInstance();
  // 表格数据列表
  const toolList = ref([]);
  // 表格loading状态
  const loading = ref(true);
  // 表格勾选框选中的 id 列表
  const ids = ref([]);
  // 多个勾选时为 true 其他为 false
  const single = ref(true);
  // 只要有勾选项就为 true
  const multiple = ref(true);

  // 多选框选中数据 
  const handleSelectionChange = (selection) => {
    ids.value = selection.map((item) => item.id);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
  };

  // 新增按钮操作
  const handleAdd = () => {
    reset();
    updateTypeOneDict();
    open.value = true;
    title.value = "添加分类";
  };

  // 点击表格上的修改按钮
  const handleSelecterUpdate = () => {
    const targetId = ids.value[0];
    formLoading.value = true;
    getToolDetailById(targetId).then((res)=>{
      handleUpdate(res.data)
    })
  }

  // 修改按钮操作 
  const handleUpdate = (row) => {
    reset();
    updateTypeOneDict();
    open.value = true;
    formLoading.value = true;
    // 获取附件数据
    listFileByBasisId({
      basisId: row.id,
      delFlag: '0'
    }).then(res=>{
      const allFiles = (res.rows || []).map(item => ({
        id: item.id,
        name: item.fileName,
        url: item.filePath,
        informationType: item.informationType
      }))
      const fileMap = groupByKey(allFiles,'informationType')
      form.value = {
        id: row.id,
        parentId: row.parentId,
        toolName: row.toolName,
        describe: row.describe,
        // 手册附件
        manualFileList: fileMap['sc'] || [],
        // 资料附件
        resourceFileList: fileMap['zl'] || [],
      };
      title.value = "修改分类";
    }).finally(()=>{
      formLoading.value = false
    })
  };
  // 删除按钮操作
  const handleDelete = (row) => {
    const toolTypeIds = row.id || ids.value;
    proxy.$modal
      .confirm('是否确认删除该分类？')
      .then(function () {
        return toolDelete(toolTypeIds);
      })
      .then(() => {
        getList();
        proxy.$modal.msgSuccess("删除成功");
      })
      .catch(() => {});
  };

  return {
    toolList,
    loading,
    single,
    multiple,
    handleAdd,
    handleSelecterUpdate,
    handleUpdate,
    handleDelete,
    handleSelectionChange
  };
};

export default useTable;
