import { queryToolDict } from "@/api/bussiness";
// 搜索表单的 hooks
const useSearchForm = (getList) => {
  const { proxy } = getCurrentInstance();
  // 搜索表单的参数
  const queryParams = ref({
    toolName: "",
    levelOneTypeId: "",
    levelTwoTypeId: "",
  })
  // 第二级类别的下拉选项
  const levelTwoDict = ref([]);
  // 一级分类选择之后查询对应的二级分类
  const handleChangeLevelOneType = (val) => {
    queryParams.value.levelTwoTypeId = ""
    if (val) {
      queryToolDict("2", val).then((data) => {
        levelTwoDict.value = data || [];
      });
    } else {
      levelTwoDict.value = [];
    }
  };
  // 搜索按钮操作
  const handleQuery = () => {
    const params = {
      toolName: queryParams.value.toolName || "",
      parentId:
        queryParams.value.levelTwoTypeId ||
        queryParams.value.levelOneTypeId ||
        undefined,
    };
    getList(params);
  };
  // 重置按钮操作
  const resetQuery = () => {
    proxy.resetForm("queryRef");
    // 清空选项和二类下拉列表
    handleChangeLevelOneType()
    handleQuery();
  };

  return {
    queryParams,
    levelTwoDict,
    handleChangeLevelOneType,
    handleQuery,
    resetQuery
  }
}

export default useSearchForm;