// 搜索表单的 hooks
const useSearchForm = (getList) => {
  const { proxy } = getCurrentInstance();
  // 搜索参数
  const queryParams = ref({
    materialNo: "",
    materialName: "",
  })
  // 搜索按钮操作
  const handleQuery = () => {
    const params = {
      materialNo: queryParams.value.materialNo || "",
      materialName: queryParams.value.materialName || "",
    };
    getList(params);
  };
  // 重置按钮操作
  const resetQuery = () => {
    proxy.resetForm("searchFormRef");
    handleQuery();
  };

  return {
    queryParams,
    handleQuery,
    resetQuery
  }
}

export default useSearchForm;