import {
  addFileByBasisId,
  updateFileById,
} from "@/api/bussiness";
// 提交表单的 hooks
const useSubmitForm = (getTableData,toolId) => {
  const { proxy } = getCurrentInstance();
  // 提交表单的表单数据
  const form = ref({
    materialNo: "",
    materialName: "",
    specifications: "",
  });
  // 表单校验规则
  const rules = ref({
    materialNo: [
      { required: true, message: "物料编码不能为空", trigger: "blur" },
    ],
    materialName: [
      { required: true, message: "物料名称不能为空", trigger: "blur" },
    ],
    specifications: [
      { required: true, message: "规格不能为空", trigger: "blur" },
    ],
  });
  // 弹窗是否打开
  const open = ref(false);
  // 弹窗标题
  const title = ref("");
  // 更新物料
  const submitUpdate = () => {
    const params = {
      ...form.value,
    }
    updateFileById(params).then(res=>{
      proxy.$modal.msgSuccess("修改成功");
      open.value = false;
      getTableData();
    })
  };

  // 添加物料
  const submitAdd = () => {
    const params = {
      ...form.value,
      basisId: +toolId.value,
      informationType: 'wl'
    }
    addFileByBasisId([params]).then(res=>{
      proxy.$modal.msgSuccess("新增成功");
      open.value = false;
      getTableData();
    })
  };
  // 提交按钮
  const submitForm = () => {
    proxy.$refs["submitFormRef"].validate((valid) => {
      if (valid) {
        if (form.value.id != undefined) {
          submitUpdate();
        } else {
          submitAdd();
        }
      }
    });
  };
  // 取消按钮
  const cancel = () => {
    open.value = false;
    reset();
  };
  // 表单重置
  const reset = () => {
    form.value = {
      materialNo: "",
      materialName: "",
      specifications: "",
    };
    proxy.resetForm("submitFormRef");
  };
  return {
    form,
    rules,
    open,
    title,
    submitForm,
    cancel,
    reset,
  };
};

export default useSubmitForm;
