import {
  deleteFileByBasisId,
} from "@/api/bussiness";
// 数据表格的 hooks
const useTable = (
  open,
  title,
  form,
  getTableData,
  reset
) => {
  const { proxy } = getCurrentInstance();
  // 表格数据
  const tableList = ref([]);
  // 表格loading状态
  const loading = ref(true);
  // 表格勾选框选中的 id 列表
  const ids = ref([]);
  // 多个勾选时为 true 其他为 false
  const single = ref(true);
  // 只要有勾选项就为 true
  const multiple = ref(true);

  // 多选框选中数据
  const handleSelectionChange = (selection) => {
    ids.value = selection.map((item) => item.id);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
  };

  // 新增按钮操作 
  const handleAdd = () => {
    reset();
    open.value = true;
    title.value = "添加物料";
  };

  // 点击表格上的修改按钮
  const handleSelecterUpdate = () => {
    const targetId = ids.value[0];
    const target = tableList.value.find(item=> item.id === targetId);
    form.value = {
      ...target
    }
    open.value = true;
    title.value = "修改物料";
  };
  // 修改按钮操作
  const handleUpdate = (row) => {
    reset();
    open.value = true;
    title.value = "修改物料";
    form.value = {
      ...row
    }
  };
  // 删除按钮操作
  const handleDelete = (row) => {
    const idList = row.id || ids.value;
    proxy.$modal
      .confirm("是否确认删除该物料？")
      .then(function () {
        return deleteFileByBasisId(idList);
      })
      .then(() => {
        getTableData()
        proxy.$modal.msgSuccess("删除成功");
      })
      .catch(() => {});
  };

  return {
    tableList,
    loading,
    single,
    multiple,
    handleSelectionChange,
    handleAdd,
    handleUpdate,
    handleDelete,
    handleSelecterUpdate,
  };
};

export default useTable;
